/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.AlertaCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.AlertaCtrl;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import java.math.BigDecimal;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("alertaCtrlDAO")
public class AlertaCtrlHibernateDAO extends GenericHibernateDAO<AlertaCtrl, Integer>
        implements AlertaCtrlDAO {

    @Autowired
    public AlertaCtrlHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<AlertaCtrl> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

    public List<AlertaCtrl> buscar(Parada origem, Parada destino, Ruta ruta,
            ClaseServicio claseServicio, Integer tiempoAlta,
            Integer tiempoBaja, BigDecimal percAlta, BigDecimal percBaja) {

        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.eq("origem", origem));
        c.add(Restrictions.eq("destino", destino));
        c.add(Restrictions.eq("ruta", ruta));
        c.add(Restrictions.eq("claseServicio", claseServicio));

        return c.list();
    }

    public List<AlertaCtrl> buscarCorrida(Corrida corrida) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        c.add(Restrictions.eq("corrida", corrida));

        return c.list();
    }
}
